/*
 * Copyright (c) 2015 by Greg Reimer <gregreimer@gmail.com>
 * MIT License. See mit-license.txt for more info.
 */

'use strict';

var _Object$assign = require('babel-runtime/core-js/object/assign')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = compilePattern;

var _deepFreeze = require('deep-freeze');

var _deepFreeze2 = _interopRequireDefault(_deepFreeze);

var _createAmender = require('./create-amender');

var _createAmender2 = _interopRequireDefault(_createAmender);

function compilePattern(pattern) {

  var newPattern = _Object$assign({ idAttribute: 'id' }, pattern);

  if (newPattern.to) {
    newPattern.amend = (0, _createAmender2['default'])(newPattern);
  }

  return (0, _deepFreeze2['default'])(newPattern);
}

module.exports = exports['default'];