/*
 * Copyright (c) 2015 by Greg Reimer <gregreimer@gmail.com>
 * MIT License. See mit-license.txt for more info.
 */

'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Object$assign = require('babel-runtime/core-js/object/assign')['default'];

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _walkObject = require('./walk-object');

var _walkObject2 = _interopRequireDefault(_walkObject);

var _ref = require('./ref');

var _ref2 = _interopRequireDefault(_ref);

var _deepFreeze = require('deep-freeze');

var _deepFreeze2 = _interopRequireDefault(_deepFreeze);

var _munge = require('./munge');

var _munge2 = _interopRequireDefault(_munge);

var _createAmender = require('./create-amender');

var _createAmender2 = _interopRequireDefault(_createAmender);

var _matchPaths = require('./match-paths');

var _matchPaths2 = _interopRequireDefault(_matchPaths);

var _default = (function () {
  function _default(opts) {
    _classCallCheck(this, _default);

    opts = _Object$assign({
      idAttribute: 'id',
      move: [],
      munge: []
    }, opts);

    opts.move = opts.move.map(compileMove);

    this._opts = (0, _deepFreeze2['default'])(opts);
  }

  _createClass(_default, [{
    key: 'toPathValues',
    value: _regeneratorRuntime.mark(function toPathValues() {
      var _iteratorNormalCompletion,
          _didIteratorError,
          _iteratorError,
          _len,
          objs,
          _key,
          _iterator,
          _step,
          obj,
          prepend,
          _iteratorNormalCompletion2,
          _didIteratorError2,
          _iteratorError2,
          _iterator2,
          _step2,
          _step2$value,
          parents,
          path,
          value,
          isLeaf,
          move,
          amended,
          isSubroot,
          idBearer,
          id,
          origPath,
          _parent,
          prop,
          args$2$0 = arguments;

      return _regeneratorRuntime.wrap(function toPathValues$(context$2$0) {
        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            context$2$0.prev = 3;

            for (_len = args$2$0.length, objs = Array(_len), _key = 0; _key < _len; _key++) {
              objs[_key] = args$2$0[_key];
            }

            _iterator = _getIterator(objs);

          case 6:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              context$2$0.next = 74;
              break;
            }

            obj = _step.value;

            (0, _munge2['default'])(obj, this._opts.munge);
            prepend = [this._opts.name, obj[this._opts.idAttribute]];
            _iteratorNormalCompletion2 = true;
            _didIteratorError2 = false;
            _iteratorError2 = undefined;
            context$2$0.prev = 13;
            _iterator2 = _getIterator((0, _walkObject2['default'])(obj));

          case 15:
            if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
              context$2$0.next = 57;
              break;
            }

            _step2$value = _step2.value;
            parents = _step2$value.parents;
            path = _step2$value.path;
            value = _step2$value.value;
            isLeaf = _step2$value.isLeaf;

            if (!(parents.length === 0)) {
              context$2$0.next = 23;
              break;
            }

            return context$2$0.abrupt('continue', 54);

          case 23:
            move = findMove(this._opts.move, path);
            amended = false;

            if (!move) {
              context$2$0.next = 44;
              break;
            }

            isSubroot = move.from.length === path.length;
            idBearer = parents[move.from.length] || value;
            id = idBearer ? idBearer[move.idAttribute] : undefined;

            if (!(id !== undefined)) {
              context$2$0.next = 39;
              break;
            }

            origPath = path;

            path = path.slice();
            move.amend(path, id);
            amended = true;

            if (!isSubroot) {
              context$2$0.next = 37;
              break;
            }

            context$2$0.next = 37;
            return { path: prepend.concat(origPath), value: (0, _ref2['default'])(path) };

          case 37:
            context$2$0.next = 44;
            break;

          case 39:
            value = { $type: 'atom', value: value };
            _parent = parents[parents.length - 1];
            prop = path[path.length - 1];

            _parent[prop] = value;
            isLeaf = true;

          case 44:
            if (!amended) {
              path = prepend.concat(path);
            }

            if (!isLeaf) {
              context$2$0.next = 50;
              break;
            }

            context$2$0.next = 48;
            return { path: path, value: value };

          case 48:
            context$2$0.next = 54;
            break;

          case 50:
            if (!Array.isArray(value)) {
              context$2$0.next = 54;
              break;
            }

            path.push('length');
            context$2$0.next = 54;
            return { path: path, value: value.length };

          case 54:
            _iteratorNormalCompletion2 = true;
            context$2$0.next = 15;
            break;

          case 57:
            context$2$0.next = 63;
            break;

          case 59:
            context$2$0.prev = 59;
            context$2$0.t0 = context$2$0['catch'](13);
            _didIteratorError2 = true;
            _iteratorError2 = context$2$0.t0;

          case 63:
            context$2$0.prev = 63;
            context$2$0.prev = 64;

            if (!_iteratorNormalCompletion2 && _iterator2['return']) {
              _iterator2['return']();
            }

          case 66:
            context$2$0.prev = 66;

            if (!_didIteratorError2) {
              context$2$0.next = 69;
              break;
            }

            throw _iteratorError2;

          case 69:
            return context$2$0.finish(66);

          case 70:
            return context$2$0.finish(63);

          case 71:
            _iteratorNormalCompletion = true;
            context$2$0.next = 6;
            break;

          case 74:
            context$2$0.next = 80;
            break;

          case 76:
            context$2$0.prev = 76;
            context$2$0.t1 = context$2$0['catch'](3);
            _didIteratorError = true;
            _iteratorError = context$2$0.t1;

          case 80:
            context$2$0.prev = 80;
            context$2$0.prev = 81;

            if (!_iteratorNormalCompletion && _iterator['return']) {
              _iterator['return']();
            }

          case 83:
            context$2$0.prev = 83;

            if (!_didIteratorError) {
              context$2$0.next = 86;
              break;
            }

            throw _iteratorError;

          case 86:
            return context$2$0.finish(83);

          case 87:
            return context$2$0.finish(80);

          case 88:
          case 'end':
            return context$2$0.stop();
        }
      }, toPathValues, this, [[3, 76, 80, 88], [13, 59, 63, 71], [64,, 66, 70], [81,, 83, 87]]);
    })
  }, {
    key: 'toGraph',
    value: function toGraph() {
      var paths = this.toPathValues.apply(this, arguments);
      var jsong = graphify(paths);
      return jsong;
    }
  }]);

  return _default;
})();

exports['default'] = _default;

function graphify(paths) {
  var jsong = {};
  var _iteratorNormalCompletion3 = true;
  var _didIteratorError3 = false;
  var _iteratorError3 = undefined;

  try {
    for (var _iterator3 = _getIterator(paths), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
      var _step3$value = _step3.value;
      var path = _step3$value.path;
      var value = _step3$value.value;

      set(jsong, path, value);
    }
  } catch (err) {
    _didIteratorError3 = true;
    _iteratorError3 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion3 && _iterator3['return']) {
        _iterator3['return']();
      }
    } finally {
      if (_didIteratorError3) {
        throw _iteratorError3;
      }
    }
  }

  return jsong;
}

function set(_x, _x2, _x3, _x4, _x5, _x6) {
  var _again = true;

  _function: while (_again) {
    var obj = _x,
        path = _x2,
        value = _x3,
        idx = _x4,
        parent = _x5,
        prevStep = _x6;
    _again = false;

    idx = idx || 0;
    var step = path[idx];
    if (!obj) {
      obj = {};
      parent && (parent[prevStep] = obj);
    }
    if (idx === path.length - 1) {
      obj[step] = value;
    } else {
      _x = obj[step];
      _x2 = path;
      _x3 = value;
      _x4 = idx + 1;
      _x5 = obj;
      _x6 = step;
      _again = true;
      step = undefined;
      continue _function;
    }
  }
}

function findMove(moves, path) {
  var _iteratorNormalCompletion4 = true;
  var _didIteratorError4 = false;
  var _iteratorError4 = undefined;

  try {
    for (var _iterator4 = _getIterator(moves), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
      var move = _step4.value;

      if ((0, _matchPaths2['default'])(move.from, path)) {
        return move;
      }
    }
  } catch (err) {
    _didIteratorError4 = true;
    _iteratorError4 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion4 && _iterator4['return']) {
        _iterator4['return']();
      }
    } finally {
      if (_didIteratorError4) {
        throw _iteratorError4;
      }
    }
  }
}

function compileMove(move) {
  var result = _Object$assign({ idAttribute: 'id' }, move);
  if (result.to) {
    result.amend = (0, _createAmender2['default'])(result);
  }
  return result;
}
module.exports = exports['default'];