/*
 * Copyright (c) 2015 by Greg Reimer <gregreimer@gmail.com>
 * MIT License. See mit-license.txt for more info.
 */

/*
const extractor = new Extractor([{
  path: [ 'users', '$key', 'avatar' ],
  handler: avatar => $ref([ 'media', avatar.id ])
}]);
const pool = extractor.pool();
pool.insert('users', users);
pool.extract(path);
*/

'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _WeakMap = require('babel-runtime/core-js/weak-map')['default'];

var _Object$create = require('babel-runtime/core-js/object/create')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _patternMap = require('./pattern-map');

var _patternMap2 = _interopRequireDefault(_patternMap);

var _obj = require('./obj');

var privates = new _WeakMap();

// ----------------------------

var Pool = (function () {
  function Pool(map) {
    _classCallCheck(this, Pool);

    var graph = _Object$create(null);
    var _ = { map: map, graph: graph };
    privates.set(this, _);
  }

  // ----------------------------

  _createClass(Pool, [{
    key: 'insert',
    value: function insert(path, item) {
      var _privates$get = privates.get(this);

      var graph = _privates$get.graph;

      (0, _obj.set)(graph, path, item);
    }
  }, {
    key: 'extract',
    value: function extract(path) {
      var _privates$get2 = privates.get(this);

      var graph = _privates$get2.graph;
      var map = _privates$get2.map;

      var value = (0, _obj.get)(graph, path);
      var handler = map.get(path) || ident;
      return handler(value);
    }
  }]);

  return Pool;
})();

var Extractor = (function () {
  function Extractor(pathHandlers) {
    _classCallCheck(this, Extractor);

    var map = new _patternMap2['default']();
    var _ = { map: map };
    privates.set(this, _);
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = _getIterator(pathHandlers), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var ph = _step.value;

        map.set(ph.path, ph.handler);
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator['return']) {
          _iterator['return']();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }

  // ----------------------------

  _createClass(Extractor, [{
    key: 'start',
    value: function start() {
      var _privates$get3 = privates.get(this);

      var map = _privates$get3.map;

      return new Pool(map);
    }
  }]);

  return Extractor;
})();

exports['default'] = Extractor;
function ident(thing) {
  return thing;
}
module.exports = exports['default'];