/*
 * Copyright (c) 2015 by Greg Reimer <gregreimer@gmail.com>
 * MIT License. See mit-license.txt for more info.
 */

'use strict';

var _Number$isInteger = require('babel-runtime/core-js/number/is-integer')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.get = get;
exports.set = set;

function get(_x3, _x4) {
  var _arguments = arguments;
  var _again = true;

  _function: while (_again) {
    var obj = _x3,
        path = _x4;
    _again = false;
    var idx = _arguments.length <= 2 || _arguments[2] === undefined ? 0 : _arguments[2];

    var len = path.length - idx;
    if (len === 0) {
      return obj;
    } else if (obj === null || obj === undefined) {
      return obj;
    } else {
      var step = path[idx];
      var child = obj[step];
      _arguments = [_x3 = child, _x4 = path, idx + 1];
      _again = true;
      idx = len = step = child = undefined;
      continue _function;
    }
  }
}

function set(_x5, _x6, _x7) {
  var _arguments2 = arguments;
  var _again2 = true;

  _function2: while (_again2) {
    var obj = _x5,
        path = _x6,
        value = _x7;
    _again2 = false;
    var parents = _arguments2.length <= 3 || _arguments2[3] === undefined ? [] : _arguments2[3];

    var len = path.length - parents.length;
    if (len === 0) {
      var _parent = parents[parents.length - 1];
      var prop = path[parents.length - 1];
      _parent[prop] = value;
    } else {
      var step = path[parents.length];
      if (obj === null || obj === undefined) {
        var _parent2 = parents[parents.length - 1];
        var prop = path[parents.length - 1];
        obj = _parent2[prop] = _Number$isInteger(step) ? [] : {};
      } else if (typeof obj !== 'object') {
        throw new TypeError('Type mismatch');
      }
      parents.push(obj);
      var child = obj[step];
      _arguments2 = [_x5 = child, _x6 = path, _x7 = value, parents];
      _again2 = true;
      parents = len = _parent = prop = step = _parent2 = prop = child = undefined;
      continue _function2;
    }
  }
}