/*
 * Copyright (c) 2015 by Greg Reimer <gregreimer@gmail.com>
 * MIT License. See mit-license.txt for more info.
 */

'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

var _Set = require('babel-runtime/core-js/set')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = walkObj;
exports.expensiveWalkObject = expensiveWalkObject;
var marked0$0 = [walkObj, expensiveWalkObject, iterate].map(_regeneratorRuntime.mark);

var _ref = require('./ref');

var _ref2 = _interopRequireDefault(_ref);

/*
 * Recursively iterate through every node in a JSON object tree.
 */

function walkObj(value, parents, path, parent, key) {
  var isLeaf, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step$value, _key, child, _isLeaf;

  return _regeneratorRuntime.wrap(function walkObj$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        parents = parents || [];
        path = path || [];
        isLeaf = isLeafNode(value);
        context$1$0.next = 5;
        return { parents: parents, path: path, value: value, isLeaf: isLeaf };

      case 5:
        // in case there was a mutation over the yield
        value = parent !== undefined ? parent[key] : value;
        isLeaf = isLeafNode(value);

        if (isLeaf) {
          context$1$0.next = 40;
          break;
        }

        parents.push(value);
        _iteratorNormalCompletion = true;
        _didIteratorError = false;
        _iteratorError = undefined;
        context$1$0.prev = 12;
        _iterator = _getIterator(iterate(value));

      case 14:
        if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
          context$1$0.next = 25;
          break;
        }

        _step$value = _step.value;
        _key = _step$value.key;
        child = _step$value.child;

        path.push(_key);
        _isLeaf = isLeafNode(child);
        return context$1$0.delegateYield(walkObj(value[_key], parents, path, value, _key), 't0', 21);

      case 21:
        path.pop();

      case 22:
        _iteratorNormalCompletion = true;
        context$1$0.next = 14;
        break;

      case 25:
        context$1$0.next = 31;
        break;

      case 27:
        context$1$0.prev = 27;
        context$1$0.t1 = context$1$0['catch'](12);
        _didIteratorError = true;
        _iteratorError = context$1$0.t1;

      case 31:
        context$1$0.prev = 31;
        context$1$0.prev = 32;

        if (!_iteratorNormalCompletion && _iterator['return']) {
          _iterator['return']();
        }

      case 34:
        context$1$0.prev = 34;

        if (!_didIteratorError) {
          context$1$0.next = 37;
          break;
        }

        throw _iteratorError;

      case 37:
        return context$1$0.finish(34);

      case 38:
        return context$1$0.finish(31);

      case 39:
        parents.pop();

      case 40:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this, [[12, 27, 31, 39], [32,, 34, 38]]);
}

var isLeafNode = (function () {
  var $jsongLeafTypes = new _Set(['ref', 'atom', 'error']);
  var $branchTypes = new _Set(['object']);
  return function (thing) {
    var isLeaf = !thing || !$branchTypes.has(typeof thing);
    var isJsongLeaf = !!thing && $jsongLeafTypes.has(thing.$type);
    return isLeaf || isJsongLeaf;
  };
})();

exports.isLeafNode = isLeafNode;
// just for testing

function expensiveWalkObject() {
  var _iteratorNormalCompletion2,
      _didIteratorError2,
      _iteratorError2,
      _iterator2,
      _step2,
      thing,
      args$1$0 = arguments;

  return _regeneratorRuntime.wrap(function expensiveWalkObject$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        _iteratorNormalCompletion2 = true;
        _didIteratorError2 = false;
        _iteratorError2 = undefined;
        context$1$0.prev = 3;
        _iterator2 = _getIterator(walkObj.apply(undefined, args$1$0));

      case 5:
        if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
          context$1$0.next = 14;
          break;
        }

        thing = _step2.value;

        thing.parents = thing.parents.slice();
        thing.path = thing.path.slice();
        context$1$0.next = 11;
        return thing;

      case 11:
        _iteratorNormalCompletion2 = true;
        context$1$0.next = 5;
        break;

      case 14:
        context$1$0.next = 20;
        break;

      case 16:
        context$1$0.prev = 16;
        context$1$0.t0 = context$1$0['catch'](3);
        _didIteratorError2 = true;
        _iteratorError2 = context$1$0.t0;

      case 20:
        context$1$0.prev = 20;
        context$1$0.prev = 21;

        if (!_iteratorNormalCompletion2 && _iterator2['return']) {
          _iterator2['return']();
        }

      case 23:
        context$1$0.prev = 23;

        if (!_didIteratorError2) {
          context$1$0.next = 26;
          break;
        }

        throw _iteratorError2;

      case 26:
        return context$1$0.finish(23);

      case 27:
        return context$1$0.finish(20);

      case 28:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[1], this, [[3, 16, 20, 28], [21,, 23, 27]]);
}

// object/array agnostic iterator
function iterate(thing) {
  var key, child;
  return _regeneratorRuntime.wrap(function iterate$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        if (!Array.isArray(thing)) {
          context$1$0.next = 11;
          break;
        }

        exports.key = key = 0;

      case 2:
        if (!(key < thing.length)) {
          context$1$0.next = 9;
          break;
        }

        child = thing[key];
        context$1$0.next = 6;
        return { key: key, child: child };

      case 6:
        exports.key = key += 1;
        context$1$0.next = 2;
        break;

      case 9:
        context$1$0.next = 21;
        break;

      case 11:
        context$1$0.t0 = _regeneratorRuntime.keys(thing);

      case 12:
        if ((context$1$0.t1 = context$1$0.t0()).done) {
          context$1$0.next = 21;
          break;
        }

        exports.key = key = context$1$0.t1.value;

        if (thing.hasOwnProperty(key)) {
          context$1$0.next = 16;
          break;
        }

        return context$1$0.abrupt('continue', 12);

      case 16:
        child = thing[key];
        context$1$0.next = 19;
        return { key: key, child: child };

      case 19:
        context$1$0.next = 12;
        break;

      case 21:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[2], this);
}